## nsync 1.26.0

=== builds/x86_32.netbsd.clang.atm-c11/Makefile ===
CC=clang
PLATFORM_CPPFLAGS=-DNSYNC_ATOMIC_C11 -I../../platform/c11 -D_POSIX_C_SOURCE=200809L -I../../platform/clang -I../../platform/netbsd -I../../platform/x86_32 -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall -Wextra -ansi -pedantic -Wno-unneeded-internal-declaration -Wno-c99-extensions
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -M
PLATFORM_C=../../platform/posix/src/nsync_semaphore_mutex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_OBJS=nsync_semaphore_mutex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/x86_64.linux.g++/Makefile ===
PLATFORM_CPPFLAGS=-DNSYNC_ATOMIC_CPP11 -I../../platform/linux -I../../platform/c++11 -D_POSIX_C_SOURCE=200809L -I../../platform/gcc -I../../platform/x86_64 -I../../platform/posix -pthread
PLATFORM_CFLAGS=-x c++ -std=c++11 -Werror -Wall -Wextra -pedantic
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -M -x c++ -std=c++11
PLATFORM_C=../../platform/linux/src/nsync_semaphore_futex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_OBJS=nsync_semaphore_futex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/x86_64.macos.c++11/Makefile ===
CC=clang++
# Some versions of MacOS (such as Sierra) require _DARWIN_C_SOURCE to include <mutex>, <condition_variable>, and <thread> (!)
PLATFORM_CPPFLAGS=-DNSYNC_USE_CPP11_TIMEPOINT -DNSYNC_ATOMIC_CPP11 -D_DARWIN_C_SOURCE -I../../platform/c++11 -I../../platform/gcc -I../../platform/macos -I../../platform/posix -pthread
PLATFORM_CFLAGS=-x c++ -std=c++11 -Werror -Wall -Wextra -pedantic
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -x c++ -M -std=c++11
# Currently, MacOS's C++11 implementation is incomplete, and does not support
# thread_local; hence the use of posix/src/per_thread_waiter.c rather than
# c++11/src/per_thread_waiter.cc
# Similarly, MacOS omits various posix calls, such as clock_gettime().
PLATFORM_C=../../platform/posix/src/clock_gettime.c ../../platform/c++11/src/nsync_semaphore_mutex.cc ../../platform/posix/src/per_thread_waiter.c ../../platform/c++11/src/yield.cc ../../platform/c++11/src/time_rep_timespec.cc ../../platform/c++11/src/nsync_panic.cc
PLATFORM_OBJS=clock_gettime.o nsync_semaphore_mutex.o per_thread_waiter.o yield.o time_rep_timespec.o nsync_panic.o
TEST_PLATFORM_C=../../platform/c++11/src/start_thread.cc
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

time_rep_timespec_test.o: ../../platform/c++11/src/time_rep_timespec_test.cc; ${CC} ${CFLAGS} -I../../testing -c ../../platform/c++11/src/time_rep_timespec_test.cc
time_rep_timespec_test: time_rep_timespec_test.o ${TEST_LIB} ${LIB}; ${CC} ${LDFLAGS} -o $@ $@.o ${TEST_LIB} ${LIB} ${PLATFORM_LIBS}

=== debian/changelog ===
nsync (1.26.0-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:17:00 +0000

nsync (1.26.0-2) unstable; urgency=medium

  * QA upload.
  * debian/libnsync-cpp1t64.symbols: Update to reflect the 64-bitness
    of time_t on the relevant arches. (Closes: #1065979)

 -- Amin Bandali <bandali@debian.org>  Fri, 15 Mar 2024 05:20:28 -0400

nsync (1.26.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063213

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 01:22:53 +0000

nsync (1.26.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Move package to QA team.

  [ Mo Zhou ]
  * New upstream version 1.26.0
  * Orphane this package. (See #1013210)
  * Bump Standards-Version to 4.6.2.

 -- Mo Zhou <lumin@debian.org>  Sun, 10 Dec 2023 16:57:25 -0500

=== debian/control ===
Source: nsync
Section: science
Homepage: https://github.com/google/nsync
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/science-team/nsync.git
Vcs-Browser: https://salsa.debian.org/science-team/nsync
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), cmake, debhelper-compat (= 13)

Package: libnsync1t64
Provides: ${t64:Provides}
Replaces: libnsync1
Breaks: libnsync1 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C library that exports various synchronization primitives (C lib)
 nsync is a C library that exports various synchronization primitives:
 .
  * locks
  * condition variables
  * run-once initialization
  * waitable counter (useful for barriers)
  * waitable bit (useful for cancellation, or other conditions)
 .
 This package ships C shared object.

Package: libnsync-cpp1t64
Provides: ${t64:Provides}
Replaces: libnsync-cpp1
Breaks: libnsync-cpp1 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C library that exports various synchronization primitives (C++ lib)
 nsync is a C library that exports various synchronization primitives:
 .
  * locks
  * condition variables
  * run-once initialization
  * waitable counter (useful for barriers)
  * waitable bit (useful for cancellation, or other conditions)
 .
 This package ships C++ shared object.

Package: libnsync-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnsync-cpp1t64 (= ${binary:Version}),
         libnsync1t64 (= ${binary:Version}),
         ${misc:Depends}
Description: C library that exports various synchronization primitives (dev)
 nsync is a C library that exports various synchronization primitives:
 .
  * locks
  * condition variables
  * run-once initialization
  * waitable counter (useful for barriers)
  * waitable bit (useful for cancellation, or other conditions)
 .
 This package ships header files.

## nsync 1.29.1

=== debian/changelog ===
nsync (1.29.1-1) unstable; urgency=medium

  * QA upload.
  * New upstream version 1.29.1
  * Drop patch included in upstream release:
      - 521eb38: Add export targets for nsync and nsync_cpp in CMakeLists.txt

 -- Dylan Aïssi <daissi@debian.org>  Sat, 29 Jun 2024 08:27:44 +0200

nsync (1.27.0-1) unstable; urgency=medium

  * QA upload.
  * New upstream version 1.27.0
  * Add Build-Depends-Package field in symbols files
  * Add Rules-Requires-Root: no
  * Add upstream metadata file
  * Drop injection of -Wl,--as-needed, no longer required
  * Cherry-pick upstream patch:
      - 521eb38: Add export targets for nsync and nsync_cpp in CMakeLists.txt
  * Install cmake files in libnsync-dev
  * Standards-Version: 4.7.0 (no changes required)

 -- Dylan Aïssi <daissi@debian.org>  Thu, 30 May 2024 21:17:06 +0200

## nsync 1.29.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

# nsync provides portable synchronization primitives, such as mutexes and
# condition variables.
if ("${CMAKE_MAJOR_VERSION}X" STREQUAL "2X")
	project (nsync)
else ()
	# fetch from VERSION file in root
	file (STRINGS VERSION VERSION_STRING)

	cmake_policy(SET CMP0048 NEW) # remove when min ver >=3

	project (nsync
		VERSION "${VERSION_STRING}")
endif ()

# Some builds need position-independent code.
set (CMAKE_POSITION_INDEPENDENT_CODE ON)

# Allow nsync users to turn the tests on or off.
option (NSYNC_ENABLE_TESTS "Enable for building tests" ON)

# -----------------------------------------------------------------
# Functions to set common options on targets and files.
# Should be called on all targets.
function (set_c_target tgtname files)
	if ("${CMAKE_SYSTEM_NAME}X" STREQUAL "LinuxX")
		target_include_directories ("${tgtname}" BEFORE PRIVATE
			"${PROJECT_SOURCE_DIR}/platform/linux"
		)
	endif ()
endfunction (set_c_target)

function (set_cpp_target tgtname files)
	target_include_directories ("${tgtname}" BEFORE PRIVATE
		"${PROJECT_SOURCE_DIR}/platform/c++11"
	)

	if ("${CMAKE_SYSTEM_NAME}X" STREQUAL "LinuxX")
		target_include_directories ("${tgtname}" BEFORE PRIVATE
			"${PROJECT_SOURCE_DIR}/platform/c++11.futex"
		)
	endif ()

	target_compile_definitions ("${tgtname}" PRIVATE "${NSYNC_CPP_DEFINITIONS}")

	foreach (s IN ITEMS ${files})
		set_source_files_properties ("${s}"
			PROPERTIES LANGUAGE CXX
			COMPILE_FLAGS "${NSYNC_CPP_FLAGS}")
	endforeach (s)
endfunction (set_cpp_target)

# -----------------------------------------------------------------
# Platform dependencies

# Many platforms use these posix related sources; even Win32.
set (NSYNC_POSIX_SRC
	"platform/posix/src/nsync_panic.c"
	"platform/posix/src/per_thread_waiter.c"
	"platform/posix/src/time_rep.c"
	"platform/posix/src/yield.c"
)

set (NSYNC_CPP_DEFINITIONS NSYNC_USE_CPP11_TIMEPOINT NSYNC_ATOMIC_CPP11)
set (NSYNC_OS_CPP_SRC
	# Avoid use of the C++11 version of per_thread_waiter.  It behaves
	# badly if multiple copies of nsync are linked into an address space.
	"platform/posix/src/per_thread_waiter.c"
	"platform/c++11/src/yield.cc"
	"platform/c++11/src/time_rep_timespec.cc"
	"platform/c++11/src/nsync_panic.cc"
)

# Many of the string matches below use a literal "X" suffix on both sides.
# This is because some versions of cmake treat (for example) "MSVC" (in quotes)
# as a reference to the variable MSVC, thus the expression
#      "${CMAKE_C_COMPILER_ID}" STREQUAL "MSVC"
# is false when ${CMAKE_C_COMPILER_ID} has the value "MSVC"!  See
#    https://cmake.org/cmake/help/v3.1/policy/CMP0054.html

if ("${CMAKE_C_COMPILER_ID}X" STREQUAL "MSVCX")
	# Suppress warnings to reduce build log size.
	add_compile_options (/wd4057 /wd4100 /wd4152 /wd4242 /wd4244 /wd4255 /wd4267)
	add_compile_options (/wd4365 /wd4389 /wd4458 /wd4571 /wd4625 /wd4626 /wd4668)
	add_compile_options (/wd4702 /wd4710 /wd4774 /wd4820 /wd5026 /wd5027 /wd5039)
	add_compile_options (/wd5045)
endif ()

# Pick the include directory for the operating system.
if ("${CMAKE_SYSTEM_NAME}X" STREQUAL "WindowsX")
	include_directories ("${PROJECT_SOURCE_DIR}/platform/win32")
	set (NSYNC_CPP_FLAGS "/TP")

	set (NSYNC_OS_SRC
		${NSYNC_POSIX_SRC}
		"platform/win32/src/clock_gettime.c"
		"platform/win32/src/init_callback_win32.c"
		"platform/win32/src/nanosleep.c"
		"platform/win32/src/nsync_semaphore_win32.c"
		"platform/win32/src/pthread_cond_timedwait_win32.c"
		"platform/win32/src/pthread_key_win32.cc"
	)
	set (NSYNC_OS_CPP_SRC
		${NSYNC_OS_CPP_SRC}
		"platform/c++11/src/nsync_semaphore_mutex.cc"
		"platform/win32/src/clock_gettime.c"
		"platform/win32/src/pthread_key_win32.cc"
	)
	set (NSYNC_TEST_OS_SRC
		"platform/win32/src/start_thread.c"
	)
elseif ("${CMAKE_SYSTEM_NAME}X" STREQUAL "DarwinX")
	include_directories ("${PROJECT_SOURCE_DIR}/platform/macos")
	# Some versions of MacOS, such as Sierra, require _DARWIN_C_SOURCE
	# when including certin C++ standard header files, such as <mutex>.
	set (NSYNC_CPP_DEFINITIONS ${NSYNC_CPP_DEFINITIONS} _DARWIN_C_SOURCE)
	set (NSYNC_POSIX ON)

	set (NSYNC_OS_EXTRA_SRC
		"platform/posix/src/clock_gettime.c"
		"platform/posix/src/nsync_semaphore_mutex.c"
	)
	set (NSYNC_OS_CPP_SRC
		${NSYNC_OS_CPP_SRC}
		"platform/c++11/src/nsync_semaphore_mutex.cc"
		"platform/posix/src/clock_gettime.c"
		"platform/posix/src/nsync_semaphore_mutex.c"
	)
elseif ("${CMAKE_SYSTEM_NAME}X" STREQUAL "LinuxX")
	set (NSYNC_POSIX ON)

	set (NSYNC_OS_EXTRA_SRC
		"platform/linux/src/nsync_semaphore_futex.c"
	)
	set (NSYNC_OS_CPP_SRC
		"platform/linux/src/nsync_semaphore_futex.c"
		${NSYNC_OS_CPP_SRC}
	)
elseif ("${CMAKE_SYSTEM_NAME}X" STREQUAL "NetBSDX")
	include_directories ("${PROJECT_SOURCE_DIR}/platform/netbsd")
	set (NSYNC_POSIX ON)

	set (NSYNC_OS_EXTRA_SRC
		"platform/posix/src/nsync_semaphore_mutex.c"
	)
	set (NSYNC_OS_CPP_SRC
		"platform/c++11/src/nsync_semaphore_mutex.cc"
		${NSYNC_OS_CPP_SRC}
	)
elseif ("${CMAKE_SYSTEM_NAME}X" STREQUAL "FreeBSDX")
	include_directories ("${PROJECT_SOURCE_DIR}/platform/freebsd")
	set (NSYNC_POSIX ON)

	set (NSYNC_OS_EXTRA_SRC
		"platform/posix/src/nsync_semaphore_mutex.c"
	)
	set (NSYNC_OS_CPP_SRC
		"platform/c++11/src/nsync_semaphore_mutex.cc"
		${NSYNC_OS_CPP_SRC}
	)
elseif ("${CMAKE_SYSTEM_NAME}X" STREQUAL "OpenBSDX")
	include_directories ("${PROJECT_SOURCE_DIR}/platform/openbsd")
	set (NSYNC_POSIX ON)

	set (NSYNC_OS_EXTRA_SRC
		"platform/posix/src/nsync_semaphore_mutex.c"
	)
	set (NSYNC_OS_CPP_SRC
		"platform/c++11/src/nsync_semaphore_mutex.cc"
		${NSYNC_OS_CPP_SRC}
	)
else ()
	set (NSYNC_POSIX ON)

	set (NSYNC_OS_EXTRA_SRC
		"platform/posix/src/nsync_semaphore_mutex.c"
	)
	set (NSYNC_OS_CPP_SRC
		"platform/c++11/src/nsync_semaphore_mutex.cc"
		${NSYNC_OS_CPP_SRC}
	)
endif ()

# Pick the include directory for the compiler.
if ("${CMAKE_C_COMPILER_ID}X" STREQUAL "GNUX")
	include_directories ("${PROJECT_SOURCE_DIR}/platform/gcc")
	set (THREADS_HAVE_PTHREAD_ARG ON)
elseif ("${CMAKE_C_COMPILER_ID}X" STREQUAL "ClangX")
	include_directories ("${PROJECT_SOURCE_DIR}/platform/clang")
	set (THREADS_HAVE_PTHREAD_ARG ON)
elseif ("${CMAKE_C_COMPILER_ID}X" STREQUAL "MSVCX")
	include_directories ("${PROJECT_SOURCE_DIR}/platform/msvc")
else ()
	message (WARNING "CMAKE_C_COMPILER_ID (${CMAKE_C_COMPILER_ID}) matched NOTHING")
endif ()

if (NSYNC_POSIX)
	include_directories ("${PROJECT_SOURCE_DIR}/platform/posix")
	set (NSYNC_CPP_FLAGS "-std=c++11")

	set (NSYNC_OS_SRC
		${NSYNC_POSIX_SRC}
		${NSYNC_OS_EXTRA_SRC}
	)
	set (NSYNC_TEST_OS_SRC
		"platform/posix/src/start_thread.c"
	)
endif ()

# Pick the include directory for the architecture.
if (("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "x86_64X") OR
    ("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "amd64X") OR
    ("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "AMD64X"))
	include_directories ("${PROJECT_SOURCE_DIR}/platform/x86_64")
elseif (("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "x86_32X") OR
	("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "i386X") OR
        ("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "i686X"))
	include_directories ("${PROJECT_SOURCE_DIR}/platform/x86_32")
elseif (("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "armv6lX") OR
	("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "armv7lX") OR
	("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "armX"))
	include_directories ("${PROJECT_SOURCE_DIR}/platform/arm")
elseif (("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "aarch64X") OR
	("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "arm64X"))
	include_directories ("${PROJECT_SOURCE_DIR}/platform/aarch64")
elseif (("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "ppcX") OR
	("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "ppc32X"))
	include_directories ("${PROJECT_SOURCE_DIR}/platform/ppc32")
elseif (("${CMAKE_SYSTEM_PROCESSOR}X" STREQUAL "ppc64X"))
	include_directories ("${PROJECT_SOURCE_DIR}/platform/ppc64")
endif ()

# Windows uses some include files from the posix directory also.
if ("${CMAKE_SYSTEM_NAME}X" STREQUAL "WindowsX")
	include_directories ("${PROJECT_SOURCE_DIR}/platform/posix")
endif ()

# -----------------------------------------------------------------

include_directories ("${PROJECT_SOURCE_DIR}/public")
include_directories ("${PROJECT_SOURCE_DIR}/internal")

include (GNUInstallDirs)

set (NSYNC_COMMON_SRC
	"internal/common.c"
	"internal/counter.c"
	"internal/cv.c"
	"internal/debug.c"
	"internal/dll.c"
	"internal/mu.c"
	"internal/mu_wait.c"
	"internal/note.c"
	"internal/once.c"
	"internal/sem_wait.c"
	"internal/time_internal.c"
	"internal/wait.c"
)

add_library (nsync ${NSYNC_COMMON_SRC} ${NSYNC_OS_SRC})
set_target_properties (nsync PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION_MAJOR})

set_c_target (nsync "${NSYNC_COMMON_SRC} ${NSYNC_OS_SRC}")

foreach (s IN ITEMS ${NSYNC_COMMON_SRC} ${NSYNC_OS_CPP_SRC})
	# The C and C++ libraries are built from the same source files but
	# compiled with either the C or C++ compiler. CMake normally detects
	# the filetype based on the extension so we need to override LANGUAGE
	# manually. A custom command first copies the source files (only if
	# changed) so the LANGUAGE property does not conflict.
	add_custom_command (
		OUTPUT cpp/${s}
		COMMAND ${CMAKE_COMMAND} -E copy_if_different ${PROJECT_SOURCE_DIR}/${s} cpp/${s}
		DEPENDS ${PROJECT_SOURCE_DIR}/${s}
	)

	set (NSYNC_CPP_SRC_COPY ${NSYNC_CPP_SRC_COPY}
		cpp/${s}
	)
endforeach (s)

add_library (nsync_cpp ${NSYNC_CPP_SRC_COPY})
set_target_properties (nsync_cpp PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION_MAJOR})

set_cpp_target (nsync_cpp "${NSYNC_CPP_SRC_COPY}")


if (NSYNC_ENABLE_TESTS)
	set (NSYNC_TEST_SRC
		"testing/array.c"
		"testing/atm_log.c"
		"testing/closure.c"
		"testing/smprintf.c"
		"testing/testing.c"
		"testing/time_extra.c"
		${NSYNC_TEST_OS_SRC}
	)
	add_library (nsync_test ${NSYNC_TEST_SRC})
	set_target_properties (nsync_test PROPERTIES
		VERSION ${PROJECT_VERSION}
		SOVERSION ${PROJECT_VERSION_MAJOR})

	set_c_target (nsync_test "${NSYNC_TEST_SRC}")
	target_include_directories (nsync_test PUBLIC
		"${PROJECT_SOURCE_DIR}/testing"
	)

	foreach (t IN ITEMS ${NSYNC_TEST_SRC})
		add_custom_command (
			OUTPUT cpp/${t}
			COMMAND ${CMAKE_COMMAND} -E copy_if_different ${PROJECT_SOURCE_DIR}/${t} cpp/${t}
			DEPENDS ${PROJECT_SOURCE_DIR}/${t}
		)

		set (NSYNC_TEST_CPP_SRC "${NSYNC_TEST_CPP_SRC}"
			"cpp/${t}"
		)
	endforeach (t)

	add_library (nsync_test_cpp ${NSYNC_TEST_CPP_SRC})
	set_target_properties (nsync_test_cpp PROPERTIES
		VERSION ${PROJECT_VERSION}
		SOVERSION ${PROJECT_VERSION_MAJOR})

	set_cpp_target (nsync_test_cpp "${NSYNC_TEST_CPP_SRC}")
	target_include_directories (nsync_test_cpp PUBLIC
		"${PROJECT_SOURCE_DIR}/testing"
	)

	# Test names should not end with _cpp
	set (NSYNC_TESTS
		"counter_test"
		"cv_mu_timeout_stress_test"
		"cv_test"
		"cv_wait_example_test"
		"dll_test"
		"mu_starvation_test"
		"mu_test"
		"mu_wait_example_test"
		"mu_wait_test"
		"note_test"
		"once_test"
		"pingpong_test"
		"wait_test"
	)

	enable_testing ()

	# Test targets to only run C or C++ tests
	add_custom_target(test_c COMMAND ${CMAKE_CTEST_COMMAND} -E '_cpp$$')
	add_custom_target(test_cpp COMMAND ${CMAKE_CTEST_COMMAND} -R '_cpp$$')

	foreach (t IN ITEMS ${NSYNC_TESTS})
		add_executable (${t} "testing/${t}.c")
		set_c_target (${t} "testing/${t}.c")
		target_include_directories (${t} PUBLIC
			"${PROJECT_SOURCE_DIR}/testing"
		)
		target_link_libraries (${t} nsync_test nsync)
		add_test (NAME ${t} COMMAND ${t})
		add_dependencies (test_c ${t})

		add_custom_command (
			OUTPUT cpp/testing/${t}.c
			COMMAND ${CMAKE_COMMAND} -E copy_if_different ${PROJECT_SOURCE_DIR}/testing/${t}.c cpp/testing/${t}.c
			DEPENDS ${PROJECT_SOURCE_DIR}/testing/${t}.c
		)

		set (NSYNC_TEST_CPP_SRC ${NSYNC_TEST_CPP_SRC}
			cpp/testing/${t}.c
		)
		add_executable (${t}_cpp "cpp/testing/${t}.c")
		set_cpp_target (${t}_cpp "cpp/testing/${t}.c")
		target_include_directories (${t}_cpp PUBLIC
			"${PROJECT_SOURCE_DIR}/testing"
		)

=== builds/aarch64.linux.gcc.sem-sem_t/Makefile ===
PLATFORM_CPPFLAGS=-D_POSIX_C_SOURCE=200809L -I../../platform/gcc -I../../platform/linux -I../../platform/aarch64 -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall -Wextra -ansi -pedantic
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -M
PLATFORM_C=../../platform/posix/src/nsync_semaphore_sem_t.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_OBJS=nsync_semaphore_sem_t.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/alpha.linux.gcc/Makefile ===
PLATFORM_CPPFLAGS=-D_POSIX_C_SOURCE=200809L -I../../platform/gcc -I../../platform/linux -I../../platform/alpha -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall -Wextra -ansi -pedantic
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -M
PLATFORM_C=../../platform/linux/src/nsync_semaphore_futex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_OBJS=nsync_semaphore_futex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/arm.linux.gcc.atm-asm.lrt/Makefile ===
PLATFORM_CPPFLAGS=-I../../platform/atomic_ind -D_POSIX_C_SOURCE=200809L -I../../platform/gcc -I../../platform/linux -I../../platform/arm -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall -Wextra -ansi -pedantic
PLATFORM_LDFLAGS=-pthread
PLATFORM_LIBS=-lrt
MKDEP=${CC} -M
PLATFORM_C=../../platform/linux/src/nsync_semaphore_futex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_S=../../platform/arm/src/nsync_atm_arm.s
PLATFORM_OBJS=nsync_atm_arm.o nsync_semaphore_futex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/ppc64.linux.gcc.lrt/Makefile ===
PLATFORM_CPPFLAGS=-D_POSIX_C_SOURCE=200809L -I../../platform/gcc -I../../platform/linux -I../../platform/ppc64 -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall -Wextra -ansi -pedantic
PLATFORM_LDFLAGS=-pthread
PLATFORM_LIBS=-lrt
MKDEP=${CC} -M
PLATFORM_C=../../platform/linux/src/nsync_semaphore_futex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_OBJS=nsync_semaphore_futex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/s390x.linux.gcc.atm-asm/Makefile ===
PLATFORM_CPPFLAGS=-I../../platform/atomic_ind -D_POSIX_C_SOURCE=200809L -I../../platform/gcc -I../../platform/linux -I../../platform/s390x -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall -Wextra -ansi -pedantic
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -M
PLATFORM_C=../../platform/linux/src/nsync_semaphore_futex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_S=../../platform/s390x/src/nsync_atm_s390x.s
PLATFORM_OBJS=nsync_atm_s390x.o nsync_semaphore_futex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/shark.netbsd.gcc.atm-os/Makefile ===
PLATFORM_CPPFLAGS=-D_POSIX_C_SOURCE=200809L -I../../platform/netbsd -I../../platform/gcc -I../../platform/shark -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall -Wextra -ansi -pedantic
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -M
PLATFORM_C=../../platform/posix/src/nsync_semaphore_mutex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_OBJS=nsync_semaphore_mutex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/x86_32.linux.clang/Makefile ===
CC=clang
PLATFORM_CPPFLAGS=-D_POSIX_C_SOURCE=200809L -I../../platform/clang -I../../platform/linux -I../../platform/x86_32 -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall -Wextra -ansi -pedantic -Wno-unneeded-internal-declaration
PLATFORM_LIBS=-lrt
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -M
PLATFORM_C=../../platform/linux/src/nsync_semaphore_futex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_OBJS=nsync_semaphore_futex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/x86_32.linux.tcc/Makefile ===
CC=tcc
PLATFORM_CPPFLAGS=-I../../platform/atomic_ind -D_POSIX_C_SOURCE=200809L -I../../platform/tcc -I../../platform/linux -I../../platform/x86_32 -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall
PLATFORM_LIBS=-lrt
PLATFORM_LDFLAGS=-pthread
MKDEP_DEPEND=mkdep
MKDEP=./mkdep ${CC} -E
PLATFORM_C=../../platform/linux/src/nsync_semaphore_futex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_S=../../platform/x86_32/src/nsync_atm_x86_32.s
PLATFORM_OBJS=nsync_atm_x86_32.o nsync_semaphore_futex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/x86_32.netbsd.c++11/Makefile ===
CC=g++
PLATFORM_CPPFLAGS=-DNSYNC_USE_CPP11_TIMEPOINT -DNSYNC_ATOMIC_CPP11 -I../../platform/c++11 -I../../platform/gcc -I../../platform/posix -pthread
PLATFORM_CFLAGS=-std=c++11 -Werror -Wall -Wextra -pedantic
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -M -std=c++11
# It's dangerous to use C++ class destructors if we can avoid it, because nsync
# may be linked into the address space multiple times, so we use the posix
# per_thread_waiter.
PLATFORM_C=../../platform/c++11/src/nsync_semaphore_mutex.cc ../../platform/posix/src/per_thread_waiter.c ../../platform/c++11/src/yield.cc ../../platform/c++11/src/time_rep_timespec.cc ../../platform/c++11/src/nsync_panic.cc
PLATFORM_OBJS=nsync_semaphore_mutex.o per_thread_waiter.o yield.o time_rep_timespec.o nsync_panic.o
TEST_PLATFORM_C=../../platform/c++11/src/start_thread.cc
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

time_rep_timespec_test.o: ../../platform/c++11/src/time_rep_timespec_test.cc; ${CC} ${CFLAGS} -I../../testing -c ../../platform/c++11/src/time_rep_timespec_test.cc
time_rep_timespec_test: time_rep_timespec_test.o ${TEST_LIB} ${LIB}; ${CC} ${LDFLAGS} -o $@ $@.o ${TEST_LIB} ${LIB} ${PLATFORM_LIBS}

=== builds/x86_32.netbsd.gcc/Makefile ===
PLATFORM_CPPFLAGS=-D_POSIX_C_SOURCE=200809L -I../../platform/gcc -I../../platform/netbsd -I../../platform/x86_32 -I../../platform/posix -pthread
PLATFORM_CFLAGS=-Werror -Wall -Wextra -ansi -pedantic
PLATFORM_LDFLAGS=-pthread
MKDEP=${CC} -M
PLATFORM_C=../../platform/posix/src/nsync_semaphore_mutex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_OBJS=nsync_semaphore_mutex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== builds/x86_32.netbsd.lcc/Makefile ===
CC=lcc
PLATFORM_CPPFLAGS=-I../../platform/atomic_ind -D_POSIX_C_SOURCE=200809L -I../../platform/lcc -I../../platform/netbsd -I../../platform/x86_32 -I../../platform/posix
PLATFORM_LIBS=-lpthread
MKDEP_DEPEND=mkdep
MKDEP=./mkdep ${CC} -E
PLATFORM_C=../../platform/posix/src/nsync_semaphore_mutex.c ../../platform/posix/src/per_thread_waiter.c ../../platform/posix/src/yield.c ../../platform/posix/src/time_rep.c ../../platform/posix/src/nsync_panic.c
PLATFORM_S=../../platform/x86_32/src/nsync_atm_x86_32.s
PLATFORM_OBJS=nsync_atm_x86_32.o nsync_semaphore_mutex.o per_thread_waiter.o yield.o time_rep.o nsync_panic.o
TEST_PLATFORM_C=../../platform/posix/src/start_thread.c
TEST_PLATFORM_OBJS=start_thread.o

include ../../platform/posix/make.common
include dependfile

=== debian/changelog ===
nsync (1.29.2-3) unstable; urgency=medium

  * QA upload.
  * d/symbols: use pkgkde-gensymbols to perform time_t substitution

 -- Shengqi Chen <harry-chen@outlook.com>  Wed, 16 Oct 2024 20:57:29 +0800

nsync (1.29.2-2) unstable; urgency=medium

  * QA upload.
  * d/rules: switch build system to cmake+ninja
  * d/symbols: replace with (more readable) mangled c++ names
  * Remove unused lintian overrides
  * d/tests: add a simple autopkgtest to run upstream checks

 -- Shengqi Chen <harry-chen@outlook.com>  Wed, 16 Oct 2024 17:18:31 +0800

nsync (1.29.2-1) unstable; urgency=medium

  * QA upload.
  * New upstream version 1.29.2

 -- Dylan Aïssi <daissi@debian.org>  Thu, 08 Aug 2024 09:42:54 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,16 @@
 Section: science
 Homepage: https://github.com/google/nsync
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/science-team/nsync.git
 Vcs-Browser: https://salsa.debian.org/science-team/nsync
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5), cmake, debhelper-compat (= 13)
+Maintainer: Debian QA Group <packages@qa.debian.org>
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+ ninja-build,
+ pkg-kde-tools
+Rules-Requires-Root: no
 
 Package: libnsync1t64
 Provides: ${t64:Provides}

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# use pkgkde-gensymbols to perform time_t substitution
export PATH := /usr/share/pkg-kde-tools/bin:$(PATH)

%:
	dh $@ --buildsystem=cmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON

=== debian/tests/control ===
Tests: upstream-test-suite
Restrictions: allow-stderr
Depends: @builddeps@
